simpleCompress.fuelMultiplier = 0.8
simpleCompress.stacksize = settings.startup["compressed-stacksize"].value
simpleCompress.CompressAmount = settings.startup["compressed-itemsinstack"].value
simpleCompress.EnergyCost = settings.startup["compressed-energy-cost"].value
simpleCompress.CompressAmount = settings.startup["compressed-itemsinstack"].value
simpleCompress.ores = settings.startup["enable-compressed-ores"].value
simpleCompress.plates = settings.startup["enable-compressed-plates"].value
simpleCompress.smelting = settings.startup["enable-compressed-smelting"].value

simpleCompress.DefaultSmeltCost = data.raw["recipe"]["iron-plate"].energy_required -- 3.2
simpleCompress.SmeltRatio = settings.startup["compressed-smeltcount-multiplier"].value
simpleCompress.CompressedSmeltAmount = math.max(1, math.floor(
  simpleCompress.CompressAmount*simpleCompress.SmeltRatio+0.001) )
-- Vanilla time for iron, copper, stone smelting = 3.2 sec
simpleCompress.CompressedSmeltCost = simpleCompress.DefaultSmeltCost *
  simpleCompress.CompressAmount * math.pow(simpleCompress.SmeltRatio, 3)
simpleCompress.CompressedSmeltCost = math.floor(simpleCompress.CompressedSmeltCost*10)/10.0 -- round to 0.1 accuracy
simpleCompress.currentSubgroup = "intermediate-product"

function SimpleCompress_AddItem(_name, _order)
  data:extend({{
    type = "item",
    name = "compressed-".. _name,
    icon = "__SimpleCompress__/graphics/compressed-".. _name ..".png",
    icon_size = 32,
    subgroup = simpleCompress.currentSubgroup,
    order = "[compressed-".. _order .."]",
    stack_size = simpleCompress.stacksize
  }})
end

function SimpleCompress_AddTintedItem(_name, _order, _icon, _tint)
  data:extend({{
    type = "item",
    name = "compressed-".. _name,
    icons = {{
      icon = "__SimpleCompress__/graphics/compressed-".. _icon ..".png",
      icon_size = 32,
      tint = _tint
    }},
    subgroup = simpleCompress.currentSubgroup,
    order = "[compressed-".. _order .."]",
    stack_size = simpleCompress.stacksize
  }})
end

function SimpleCompress_AddRecipe(_name, _ingredient)
  _ingredient = _ingredient or _name
  data:extend({{
    type = "recipe",
    name = "compress-" .. _name,
    energy_required = simpleCompress.EnergyCost,
    category = "advanced-crafting",
    enabled = false,
    ingredients = {{_ingredient, simpleCompress.CompressAmount}},
    result = "compressed-" .. _name
  },
  {
    type = "recipe",
    name = "decompress-" .. _name,
    energy_required = simpleCompress.EnergyCost,
    category = "advanced-crafting",
    enabled = false,
    ingredients = {{"compressed-" .. _name, 1}},
    result = _ingredient,
	  result_count = simpleCompress.CompressAmount
  }})
end

function SimpleCompress_AddSmeltingRecipe(_name, _result)
  data:extend({{
    type = "recipe",
    name = "smelt-compressed-".. _name,
    energy_required = simpleCompress.CompressedSmeltCost,
    category = "smelting",
    enabled = false,
    ingredients = {{"compressed-".. _name, 1}},
    result = _result,
    result_count = simpleCompress.CompressedSmeltAmount
  }})
end

function SimpleCompress_UnlockOreTech(_name)
  local eff = data.raw.technology["orecompresstech"].effects
  table.insert(eff, { type = "unlock-recipe",	recipe = "compress-" .. _name })
  table.insert(eff, { type = "unlock-recipe",	recipe = "decompress-" .. _name })
end

function SimpleCompress_UnlockOreSmeltingTech(_name)
  local eff = data.raw.technology["orecompresstech"].effects
  table.insert(eff, { type = "unlock-recipe",	recipe = "smelt-compressed-" .. _name })
end

function SimpleCompress_UnlockPlateTech(_name)
  local eff = data.raw.technology["platecompresstech"].effects
  table.insert(eff, { type = "unlock-recipe",	recipe = "compress-" .. _name })
  table.insert(eff, { type = "unlock-recipe",	recipe = "decompress-" .. _name })
end

function SimpleCompress_UnlockPlateSmeltingTech(_name)
  local eff = data.raw.technology["platecompresstech"].effects
  table.insert(eff, { type = "unlock-recipe",	recipe = "smelt-compressed-" .. _name })
end

function SimpleCompress_UnlockOreTechAndRecipe(_name)
  SimpleCompress_AddRecipe(_name)
  SimpleCompress_UnlockOreTech(_name)
end

function SimpleCompress_UnlockPlateTechAndRecipe(_name)
  SimpleCompress_AddRecipe(_name)
  SimpleCompress_UnlockPlateTech(_name)
end