-- Steel smelting
local CompressedIronAmount = 2 -- Number of compressed iron plates to smelt at the time
local CompressedSteelAmount = math.max(1,
  math.floor((CompressedIronAmount*simpleCompress.CompressAmount/5)*simpleCompress.SmeltRatio+0.001) )
-- Vanilla time for steel smelting = 16 sec (3.2 * 5)
local CompressedSteelSmeltCost = simpleCompress.DefaultSmeltCost*5 * 
  CompressedSteelAmount * math.pow(simpleCompress.SmeltRatio, 3)
CompressedSteelSmeltCost = math.floor(CompressedSteelSmeltCost*10)/10.0 -- round to 0.1 accuracy

-- Compressed ores
if simpleCompress.ores then
  SimpleCompress_AddRecipe("iron-ore", "iron-ore")
  SimpleCompress_AddRecipe("copper-ore", "copper-ore")
  SimpleCompress_AddRecipe("uranium-ore", "uranium-ore")
  SimpleCompress_AddRecipe("stone", "stone")
  SimpleCompress_AddRecipe("coal", "coal")
  
  if simpleCompress.smelting then
    SimpleCompress_AddSmeltingRecipe("iron-ore", "iron-plate")
    SimpleCompress_AddSmeltingRecipe("copper-ore", "copper-plate")
    SimpleCompress_AddSmeltingRecipe("stone", "stone-brick")
    
    -- 2 stones => 1 stone brick
    local brickRecipe = data.raw.recipe["smelt-compressed-stone"]
    brickRecipe.ingredients = {{"compressed-stone", 2}}
  end
end

-- Compressed plates
if simpleCompress.plates then
  SimpleCompress_AddRecipe("iron", "iron-plate")
  SimpleCompress_AddRecipe("copper", "copper-plate")
  SimpleCompress_AddRecipe("steel", "steel-plate")
  
  if simpleCompress.smelting then
    data:extend({{
      type = "recipe",
      name = "smelt-compressed-iron",
      category = "smelting",
      normal = {
        enabled = false,
        energy_required = CompressedSteelSmeltCost,
        ingredients = {{"compressed-iron", CompressedIronAmount}},
        result = "steel-plate",
        result_count = CompressedSteelAmount
      },
      expensive = { -- x2 normal recipe
        enabled = false,
        energy_required = CompressedSteelSmeltCost*2,
        ingredients = {{"compressed-iron", CompressedIronAmount*2}},
        result = "steel-plate",
        result_count = CompressedSteelAmount
      }
    }})
  end
end