require "util"
require("mod-gui")
--require("table")
require("control-util")
--require "style"

MOD_NAME = "TrainManager"


get_sprite_button = function(player)
	-- debugp("in get_sprite_button")
  local button_flow = mod_gui.get_button_flow(player)
  local button = button_flow.tm_sprite_button
    if button then
	  if player.force.technologies["train-manager"].researched ~= true then
        button.destroy()
	  end
      return
    end
  if not button then
    button = button_flow.add
    {
      type = "sprite-button",
      name = "tm_sprite_button",
      sprite = "train_manager",
      style = mod_gui.button_style,
--      tooltip = {"gui-trainps.button-tooltip"}
    }
 --   button.style.visible = any
	if player.mod_settings["ps-tooltip"].value == true then
		button.tooltip = {"gui-trainps.button-tooltip"}
	end
  end
  return button
end

script.on_event(defines.events.on_research_finished, function(event)

    if event.research.name == 'train-manager' then
        for _, player in pairs(game.players) do
            get_sprite_button(player)
        end
    end

end)


local function on_player_created(event)
	if game.players[event.player_index].force.technologies["train-manager"].researched == true then
		get_sprite_button(game.players[event.player_index])
    end
end

local function on_player_joined_game(event)
	-- debugp("Player joined game")
	if game.players[event.player_index].force.technologies["train-manager"].researched == true then
		get_sprite_button(game.players[event.player_index])
	end
end

-- Fuel handling
local function on_configuration_changed(modlist)
	--global.removeFuelStop = global.removeFuelStop or {}	
	getEnergyList()
	if modlist.mod_changes["train-pubsub"] then
		if modlist.mod_changes["train-pubsub"].old_version == nil then
			modlist.mod_changes["train-pubsub"].old_version = "0.0.0"
		end
		if modlist.mod_changes["train-pubsub"].old_version < "0.3.7" then
			global.trains = global.trains or {}
			for _, surface in pairs(game.surfaces) do
				local trains = surface.get_trains()
				for _,train in pairs(trains) do
					global.trains[train.id] = train
				end
			end

		end
		if modlist.mod_changes["train-pubsub"].old_version < "0.3.13" then
			for _,force in pairs(game.forces) do
				if (force.technologies["train-manager"].researched) then
			--	for _,player in pairs(game.players) do
					force.recipes["train-config"].enabled=true
				end
			--	end
			end
		end
	end
end

local function onLoad()
	--global.removeFuelStop = global.removeFuelStop or {}
	getEnergyList()
	nth_tick()
end

function getEnergyList()
	global.EnergyList = global.EnergyList or {}
	for _,item in pairs(game.item_prototypes) do
		if item.fuel_category then
			--table.insert(global.EnergyList,{name=item.name,fuel_value=item.fuel_value})
			global.EnergyList[item.name] = item.fuel_value
		end
	end
end

function lowFuel(loc)
	local loc_inv = loc.get_fuel_inventory()
	if not loc_inv then return false end
	local contents = loc_inv.get_contents()
	local min_fuel = settings.global['min-fuel-amount'].value * loc.prototype.max_energy_usage * 800
	min_fuel = min_fuel / loc.prototype.burner_prototype.effectivity
	if getEnergy(contents) < min_fuel then
		return true
	else
		return false
	end
end

function getEnergy(list)
	local e = 0
	for name,amount in pairs(list) do
		-- for _,item in pairs(global.EnergyList) do
			-- if item.name == name then

		e = e + (global.EnergyList[name] * amount) 
			-- break
			-- end
		-- end
	end
	return e
end


function onInit()
	global.PubSubOpened = global.PubSubOpened or {}

	for _, player in pairs(game.players) do
		get_sprite_button(player)
	end
	getEnergyList()
end

function map_ping(player,x,y,text)
	--debugp(x .. " : " .. " : " .. text)
	player.force.add_chart_tag(player.surface,{icon={type="item",name="train-publisher"},position={x=x+5,y=y},text=text})
end

local function gui_open_frame(player)
	local gui = mod_gui.get_frame_flow(player)
	local frame = gui.tm_button_frame
	frame.add{
		type = "sprite-button",
		name = "es_button",
		sprite = "sub_train_stop",
		style = mod_gui.button_style
	}
	frame.add{
		type = "sprite-button",
		name = "publish_button",
		sprite = "publisher",
		style = mod_gui.button_style
	}
	frame.add{
		type = "sprite-button",
		name = "priority_button",
		sprite = "priority",
		style = mod_gui.button_style
	}
	frame.add{
            type = "sprite-button",
			name = "subscribe_button",
			sprite = "trains",
			style = mod_gui.button_style
        }
		frame.add{
            type = "sprite-button",
			name = "match_button",
			sprite = "key",
			style = mod_gui.button_style
        }
		frame.add{
            type = "sprite-button",
			name = "rq_button",
			sprite = "x",
			style = mod_gui.button_style
        }
	-- game.write_file("ps_setting",serpent.block(player.mod_settings["ps-tooltip"]),{comment=false})
	-- debugp(tostring(player.mod_settings["ps-tooltip"]))
	if player.mod_settings["ps-tooltip"].value == true then
	--debugp("mod setting true")
		frame.subscribe_button.tooltip = {"gui-trainps.s-tooltip"}
		frame.publish_button.tooltip = {"gui-trainps.r-tooltip"}
		frame.priority_button.tooltip = {"gui-trainps.pri-tooltip"}
		frame.match_button.tooltip = {"gui-trainps.k-tooltip"}
		frame.es_button.tooltip = {"gui-trainps.es-tooltip"}
		frame.rq_button.tooltip = {"gui-trainps.rq-tooltip"}
	end
end

local function gui_open_subtable(player)
	local gui = mod_gui.get_frame_flow(player)
	local frame = gui.sub_table
	if not frame then return end
	frame.clear()
	local sub_title = frame.add{type = "label", caption = {"subscriptions-title"}, style = "caption_label"}
	local scroll = frame.add{type = "scroll-pane", name = "scroll"}
	scroll.style.maximal_height = 500
	local subscriptions = scroll.add{type = "table", name = "subscriptions", column_count = 2, style = "PubSub_table_style"}
	global.subscriptions = global.subscriptions or {}
	for i,subs in pairs(global.subscriptions) do
		local status,err = pcall(function()
		subscriptions.add{type = "label", caption = subs}
		subscriptions.add{type = "label", caption = i}
		-- subscriptions.add{type = "label", caption = subs.train.id}
		end)
		if not status then
			for _,players in pairs(game.players) do
			players.print(err)
			global.subscriptions[i] = nil
			end
		end
	end
end

local function gui_open_pubtable(player)
	local gui = mod_gui.get_frame_flow(player)
	local frame = gui.pub_table
	if not frame then return end
	frame.clear()
	local pub_title = frame.add{type = "label", caption = {"publish-title"}, style = "caption_label"}
	local scroll = frame.add{type = "scroll-pane", name = "scroll"}
	scroll.style.maximal_height = 500
	-- scroll.vertical_scroll_policy = "auto-and-reserve-space"
	local requests = scroll.add{type = "table", name = "requests", column_count = 3, style = "PubSub_table_style"}

	if global.publishers then
		for n,req in pairs(global.publishers) do
			-- requests.add{}
			local ping = requests.add{type = "button", name = "pub_ping" .. n, style = "PubSub_edit_button_style", caption = "p"}
			if req.priority.name then
				local resource = requests.add{type = "choose-elem-button", name = "Resource" .. n, elem_type = "signal", signal = {type = req.priority.type, name = req.priority.name}}
				resource.locked = true	
			else
				requests.add{type = "label", caption = {"train-controller.not-defined"}}
			end
			requests.add{type = "label", caption = req.backer_name}
		-- requests.add{type = "label", caption = subs.train.id}
			if player.mod_settings["ps-tooltip"].value == true then
				ping.tooltip = {"gui-trainps.ping-tooltip"}
			end
		end
	end
end

local function gui_open_estable(player)
	local gui = mod_gui.get_frame_flow(player)
	local frame = gui.es_table
	if not frame then return end
	frame.clear()
	local es_title = frame.add{type = "label", caption = {"es-title"}, style = "caption_label"}
	local scroll = frame.add{type = "scroll-pane", name = "scroll"}
	scroll.style.maximal_height = 500
	local es = scroll.add{type = "table", name = "es", column_count = 1, style = "PubSub_table_style"}

	-- for _,rows in pairs(global.entitystation) do
		-- es.add{type = "label", caption = rows.name}
		-- es.add{type = "label", caption = rows.backer_name}
	-- end
	for _,station in pairs(player.surface.find_entities_filtered{type="train-stop", name="subscriber-train-stop"}) do
	--	es.add{type = "label", caption = station.name}
		es.add{type = "label", caption = station.backer_name}
	end
end

local function gui_open_rqtable(player)
	local gui = mod_gui.get_frame_flow(player)
	local frame = gui.rq_table
	if not frame then return end
	frame.clear()
	local rq_title = frame.add{type = "label", caption = {"rq-title"}, style = "caption_label"}
	local scroll = frame.add{type = "scroll-pane", name = "scroll"}
	scroll.style.maximal_height = 800
	local rq = scroll.add{type = "table", name = "rq", column_count = 5, style = "PubSub_table_style"}
	if global.requests then
		for n,rows in pairs(global.requests) do
			local ping = rq.add{type = "button", name = "rq_ping" .. n, style = "PubSub_edit_button_style", caption = "p"}
			rq.add{type = "choose-elem-button", name = "Resource" .. n, elem_type = "signal", signal = {type = rows.priority.type, name = rows.priority.name}}
			rq.add{type = "label", caption = tostring(rows.backer_name)}
			local minutes = math.floor((game.tick - rows.tick) / 3600)
			if minutes < 0 then minutes = 0 end
			rq.add{type = "label", caption = {"mins"}}
			rq.add{type = "label", caption = tostring(minutes)}
			if player.mod_settings["ps-tooltip"].value == true then
				ping.tooltip = {"gui-trainps.ping-tooltip"}
			end
		end
	end
end

function auto_update()
	for _,player in pairs(game.players) do
		local gui = mod_gui.get_frame_flow(player)
		local frame = gui.rq_table
		if frame then
			frame.clear()
			gui_open_rqtable(player)
		end
	end
end

local function gui_open_key_frame(player)
	local gui = mod_gui.get_frame_flow(player)
	local frame = gui.key_frame
	--debugp("In key frame")
--	if not frame then return end
--	frame.clear()
	local key_title = frame.add{type = "label", caption = {"key-title"}, style = "caption_label"}
	local scroll = frame.add{type = "scroll-pane", name = "scroll"}
	scroll.style.maximal_height = 800
	local key_s = scroll.add{type = "table", name = "key_s", column_count = 2, style = "PubSub_table_style"}
	global.sub_index = global.sub_index or {}
	global.subscriptions = global.subscriptions or {}
	for k,subs in pairs(global.sub_index) do
		key_s.add{type = "label", caption = k}
		key_s.add{type = "label", caption = subs }
	end

end

local function stationlist(priority)
	local temp = ""
		-- temp = table.concat(priority.station)
	if priority.station then
		for _, station in ipairs(priority.station) do
			temp = temp .. station[2] .. "  :  "
		end
	end
	return temp
end

function gui_open_station_frame(player, mode)
	local gui = mod_gui.get_frame_flow(player)
	local frame = gui.station_frame

--	game.write_file("global",serpent.block(global),{comment=false})

	if not frame then return end
	frame.clear()
	local wc = {}

	if global.priority[global.player[player.index].cur_priority] then
		debugp(global.player[player.index].cur_priority .. ":" .. #global.priority+1)
		if global.player[player.index].cur_priority == #global.priority+1 then
			global.player[player.index].wc = {}
			wc = global.player[player.index].wc
		else

			if not(global.priority[global.player[player.index].cur_priority].wc ) then
				global.priority[global.player[player.index].cur_priority].wc = {rb_or = true, rb_and = false, inc_ef = true, empty = true, full = false, inactivity = true, inact_int = 5, wait_timer = false, wait_int = 30}
			end
			wc = global.priority[global.player[player.index].cur_priority].wc
		end
		local wc_title = frame.add{type = "label", caption = {"wc.wait-conditions"}, style = "caption_label"}
		local andor_table = frame.add{type = "table", name = "andortable", column_count = 2, style = "PubSub_table_style"}
		local rb_or   = andor_table.add{type = "radiobutton", name = "rb_or", caption = {"wc.or"}, state = wc.rb_or}
		local rb_and  = andor_table.add{type = "radiobutton", name = "rb_and", caption = {"wc.and"}, state = wc.rb_and}
		local ef_table = frame.add{type = "table", name = "eftable", column_count = 3, style = "PubSub_table_style"}
		local inc_ef = ef_table.add{type = "checkbox", name = "efinc", caption = {"wc.include"}, state = wc.inc_ef}
		local empty = ef_table.add{type = "radiobutton", name = "empty", caption = {"wc.empty"}, state = wc.empty}
		local full = ef_table.add{type = "radiobutton", name = "full", caption = {"wc.full"}, state = wc.full}
		local inact_table = frame.add{type = "table", name = "inact_table", column_count = 2}
		local inactivity = inact_table.add{type = "checkbox", name = "inactivity", caption = {"wc.inactivity"}, state = wc.inactivity}
		local inact_int = inact_table.add{type = "textfield", name = "inact_int", caption = {"wc.period"}, text = wc.inact_int}
		inact_int.style.maximal_width = 40
		local inact_slider = frame.add{type = "slider", name = "inact_slider", minimum_value = 1, maximum_value = 200, value = wc.inact_int}

		local rb_table = frame.add{type = "table", name = "rbtable", column_count = 2}
		local wait_timer = rb_table.add{type = "checkbox", name = "wait_timer", caption = {"wc.wait-timer"}, state = wc.wait_timer}
		local wait_int = rb_table.add{type = "textfield", name = "wait_int", caption = {"wc.wait"}, text = wc.wait_int}
		wait_int.style.maximal_width = 40
		local wait_slider = frame.add{type = "slider", name = "wait_slider", minimum_value = 1, maximum_value = 200, value = wc.wait_int}

	end

	local station_title = frame.add{type = "label", caption = {"train-controller.select-stations"}, style = "caption_label"}

	for _,stationX in ipairs(global.player[player.index].station) do
		frame.add{type = "label", caption = stationX[2]}
	end
	frame.add{type= "drop-down", name = "station_dd", items = global.player[player.index].list}

	if mode == "add" then 
		global.player[player.index].bname = "tsm_save_station_button"
		global.player[player.index].bcaption = {"train-controller.save"}
	elseif mode == "edit" then
		global.player[player.index].bname = "tsm_update_station_button"
		global.player[player.index].bcaption = {"train-controller.update"}
	end
	frame.add{
	    type = "button",
        name = global.player[player.index].bname,
		style = mod_gui.button_style,
        caption = global.player[player.index].bcaption
        }
end

local function gui_open_pri_frame(player)
	local gui = mod_gui.get_frame_flow(player)
	local frame = gui.pri_frame	
	if not frame then return end
	frame.clear()
	local pri_title = frame.add{type = "label", caption = {"priorities-title"}, style = "caption_label"}
	local scroll = frame.add{type = "scroll-pane", name = "scroll"}
	scroll.style.maximal_height = 500
	local ptable = scroll.add{type = "table", name = "ptable", column_count = 6, style = "PubSub_table_style"}
	ptable.add{type = "label", caption = " "}
	ptable.add{type = "label", caption = " "}
	ptable.add{type = "label", caption = " "}
	ptable.add{type = "label", caption = {"train-controller.resource"}}
	ptable.add{type = "label", caption = {"train-controller.id"}}
	ptable.add{type = "label", caption = {"train-controller.station-list"}}
	global.priority = global.priority or {}
	for n, priority in ipairs(global.priority) do
		-- debugp("n" .. n .. "res" .. priority.resource.name .. " : id" .. priority.id.name)
		local premove = ptable.add{type = "button", name = "ps_remove" .. n, style = "PubSub_edit_button_style", caption = "-"}
		local delete = ptable.add{type = "button", name = "ps_delete" .. n, style = "PubSub_edit_button_style", caption = "x"}
		local edit = ptable.add{type = "button", name = "ps_edit" .. n, style = "PubSub_edit_button_style", caption = "e"}
		local resource = ptable.add{type = "choose-elem-button", name = "Resource" .. n, elem_type = "signal", signal = {type = priority.resource.type, name = priority.resource.name}}
		resource.locked = true
		local id = ptable.add{type = "choose-elem-button", name = "Id" .. n, elem_type = "signal", signal = {type = priority.id.type, name = priority.id.name}}
		id.locked = true
		ptable.add{type = "label", name = "Stations" .. n, caption = stationlist(priority)}
		if player.mod_settings["ps-tooltip"].value == true then
			premove.tooltip = {"gui-trainps.premove-tooltip"}
			delete.tooltip = {"gui-trainps.delete-tooltip"}
			edit.tooltip = {"gui-trainps.edit-tooltip"}
		end
	end
	ptable.add{type = "label", caption = " "}
	ptable.add{type = "label", caption = " "}
	ptable.add{type = "label", caption = " "}
	ptable.add{type = "choose-elem-button", name = "Resource", elem_type = "signal"}
	ptable.add{type = "choose-elem-button", name = "Id", elem_type = "signal"}
	ptable.add{
        type = "button",
        name = "select_station_button",
		style = mod_gui.button_style,
        caption = {"train-controller.select"}
        }
end

function on_gui_elem_changed(event)
	local status,err = pcall(function()
    local element = event.element
    local player = game.players[event.player_index]	
	global.player[event.player_index] = global.player[event.player_index] or {}
	global.player[event.player_index].resource = global.player[event.player_index].resource or {}
	-- resource.elem_value = resource.elem_value or {}
	global.player[event.player_index].id = global.player[event.player_index].id or {}
	-- id.elem_value = id.elem_value or {}

	if element.name == "Resource" then
		-- resource = table.deepcopy(element)
		global.player[event.player_index].resource.elem_type = element.elem_type
		global.player[event.player_index].resource.type = element.elem_value.type
		global.player[event.player_index].resource.name = element.elem_value.name
	--	debugp("resource" .. global.player[event.player_index].resource.name)
	elseif element.name == "Id" then
		-- id = table.deepcopy(element)
		global.player[event.player_index].id.elem_type = element.elem_type
		global.player[event.player_index].id.type = element.elem_value.type
		global.player[event.player_index].id.name = element.elem_value.name
	--	debugp("Id".. global.player[event.player_index].id.name)
	--	debugp(event.player_index)
	elseif element.name == "Schema" then
		-- debugp(player.opened.name)
		-- local publisher = global.publishers[player.opened]
		local found = false
		for _,publisher in pairs(global.publishers) do
			if publisher.entity == player.opened then
				--debugp("found")
				publisher.priority = publisher.priority or {}
				publisher.priority.elem_type = element.elem_type
				publisher.priority.type = element.elem_value.type
				publisher.priority.name = element.elem_value.name
				gui_close(player, player.opened)
				gui_open(player, player.opened)
				found = true
				break
			end
		end
	--	debugp("Need update publisher?")
		if not(found) then
		--	debugp("Not found")
			global.publishers = global.publishers or {}
			local priority = {elem_type = element.elem_type,type = element.elem_value.type,name = element.elem_value.name}
			for _,station in pairs(player.opened.surface.find_entities_filtered{area={{x=player.opened.position.x - 2,y=player.opened.position.y - 2},{x=player.opened.position.x + 2,y=player.opened.position.y + 2}},type="train-stop"}) do
				table.insert(global.publishers, {entity = player.opened, backer_name = station.backer_name, enabled = false, priority = priority, request = false})
			-- debugp("Publisher found at" .. station.backer_name)
			end
		end
	end
	end)
end

local function on_gui_selection_state_changed(event)
    local element = event.element
    local player = game.players[event.player_index]	
	local status,err = pcall(function()
		debugp(element.name)
	if element.name == "station_dd" then
		local item = {"",global.player[event.player_index].list[element.selected_index]}	

		table.insert(global.player[event.player_index].station, item)
  --  game.write_file("apend_stations",serpent.block(station),{comment=false})
		gui_open_station_frame(player)
	end
	end)
end

local function on_gui_click(event)
    local element = event.element
    local player = game.players[event.player_index]
	local gui = mod_gui.get_frame_flow(player)
	local frame = gui.tm_button_frame
	local curlist = nil

	global.player = global.player or {}
	global.player[event.player_index] = global.player[event.player_index] or {}

    if element.name == "tm_sprite_button" then
	    if frame then
			if gui.sub_table then gui.sub_table.destroy() end
			if gui.pub_table then gui.pub_table.destroy() end
			if gui.es_table then gui.es_table.destroy() end
			if gui.rq_table then gui.rq_table.destroy() end
			if gui.pri_frame then gui.pri_frame.destroy() end
			if gui.station_frame then gui.station_frame.destroy() end
			if gui.key_frame then gui.key_frame.destroy() end
			frame.destroy()
			return
		end
		frame = gui.add{
			type = "frame",
			name = "tm_button_frame",
			direction = "horizontal",
			style = mod_gui.frame_style
		}
        gui_open_frame(player)

 
	elseif element.name == "subscribe_button" then
		local subtable = gui.sub_table
		if subtable then
			subtable.destroy()
			return
		end
		subtable = gui.add{	
			type = "frame",
			name = "sub_table",
			direction = "vertical",
			style = mod_gui.frame_style
			}
		gui_open_subtable(player)

	elseif element.name == "publish_button" then
		local pubtable = gui.pub_table
		if pubtable then
			pubtable.destroy()
			return
		end
		pubtable = gui.add{	
			type = "frame",
			name = "pub_table",
			direction = "vertical",
			style = mod_gui.frame_style
			}
		gui_open_pubtable(player)
 
	elseif element.name == "es_button" then
		local estable = gui.es_table
		if estable then
			estable.destroy()
			return
		end
		estable = gui.add{	
			type = "frame",
			name = "es_table",
			direction = "vertical",
			style = mod_gui.frame_style
			}
		gui_open_estable(player)

	elseif element.name == "rq_button" then
		local rqtable = gui.rq_table
		if rqtable then
			rqtable.destroy()
			return
		end
		rqtable = gui.add{
			type = "frame",
			name = "rq_table",
			direction = "vertical",
			style = mod_gui.frame_style
			}
		gui_open_rqtable(player)
	
	elseif element.name == "priority_button" then
		local pri_frame = gui.pri_frame
		if pri_frame then
			pri_frame.destroy()
			if gui.station_frame then
				gui.station_frame.destroy()
			end
			return
		end
		pri_frame = gui.add{
			type = "frame",
			name = "pri_frame",
			direction = "vertical",
			style = mod_gui.frame_style
			}
		-- debugp("clearing resource")
		global.player[event.player_index] = global.player[event.player_index] or {}
		global.player[event.player_index].resource = {}
		global.player[event.player_index].id = {}
		gui_open_pri_frame(player)

	elseif element.name == "select_station_button" then
		local station_frame = gui.station_frame
		if station_frame then
			station_frame.destroy()
			return
		end
		if (global.player[event.player_index].resource.name ~= nil) and (global.player[event.player_index].id.name ~= nil) then
		-- check for non-duplicate id
			local dupe = false
			for _, priority in pairs(global.priority) do
				if priority.id.name == global.player[event.player_index].id.name then
					dupe = true
					break
				end
			end
			if dupe == false then
				station_frame = gui.add{
					type = "frame",
					name = "station_frame",
					direction = "vertical",
					style = mod_gui.frame_style
					}
			-- debugp("Clearing station")
				global.player[event.player_index].station = {}		
				global.player[event.player_index].list = {}
				listidx = {}
				for _,stat in pairs(player.surface.find_entities_filtered{type="train-stop", name="subscriber-train-stop"}) do	
					listidx[stat.backer_name] = stat.backer_name
				end
				--table.sort(listidx,function(a,b) return a<b end)
				for _,listidx in spairs(listidx, function(t,a,b) return t[b] > t[a] end) do
					table.insert(global.player[event.player_index].list,listidx)
				--	table.sort(global.player[event.player_index].list)
				end
				global.player[player.index].cur_priority = #global.priority+1
				gui_open_station_frame(player, "add")
			else
				game.players[event.player_index].print({"errors.unique_id"})
			end
		else
			game.players[event.player_index].print({"errors.resource_id"})
		end

	elseif element.name == "tsm_save_station_button" then
		local value = {resource = global.player[event.player_index].resource, id = global.player[event.player_index].id, station = global.player[event.player_index].station}
		global.priority[#global.priority+1] = table.deepcopy(value)
		global.priority[#global.priority].wc = global.player[player.index].wc
		-- debugp("global priority size" .. #global.priority)
		--write_file("update_values",serpent.block(value),{comment=false})

		updaterequestedpublisher(value.id.name)
		gui.station_frame.destroy()
		gui_open_pri_frame(player)


	elseif element.name == "match_button" then
		local key_frame = gui.key_frame
		if key_frame then
			key_frame.destroy()
			return
		end
		key_frame = gui.add{
			type = "frame",
			name = "key_frame",
			direction = "vertical",
			style = mod_gui.frame_style
			}
		gui_open_key_frame(player)

	elseif string.find(element.name, "ps_edit")  then
		local station_frame = gui.station_frame
		if station_frame then
			station_frame.destroy()
			return
		end
		station_frame = gui.add{
			type = "frame",
			name = "station_frame",
			direction = "vertical",
			style = mod_gui.frame_style
			}
		-- debugp("Clearing station")
		global.player[event.player_index] = global.player[event.player_index] or {}
		global.player[event.player_index].station = {}
		global.player[event.player_index].cur_priority = tonumber(string.match(element.name, "%d+"))		
		if global.priority[global.player[event.player_index].cur_priority].station then
		--	game.write_file("edit_stations",serpent.block(global.priority[cur_priority].station),{comment=false})
			for i, stationX in ipairs(global.priority[global.player[event.player_index].cur_priority].station) do
				global.player[event.player_index].station[#global.player[event.player_index].station + 1] = stationX
			 --	table.insert(station,StationX)
			end	
		end
		global.player[event.player_index].list = {}
		listidx = {}
		for _,station in pairs(player.surface.find_entities_filtered{type="train-stop", name="subscriber-train-stop"}) do	
		--	if curlist ~= station.backer_name then
				listidx[station.backer_name] = station.backer_name
		--		table.insert(list, {"",station.backer_name})
		--		curlist = station.backer_name
		--	end
		end
		for _,listidx in spairs(listidx, function(t,a,b) return t[b] > t[a] end) do
			table.insert(global.player[event.player_index].list,listidx)
		end
		-- for _, es in pairs(global.entitystation) do
			-- table.insert(list, {"",es.backer_name})
		-- end
		gui_open_station_frame(player, "edit")

	elseif string.find(element.name, "ps_delete")  then
		local station_frame = gui.station_frame
		if station_frame then
			station_frame.destroy()
			return
		end
		station_frame = gui.add{
			type = "frame",
			name = "station_frame",
			direction = "vertical",
			style = mod_gui.frame_style
			}
		-- debugp("Clearing station")
		global.player[event.player_index] = global.player[event.player_index] or {}
		global.player[event.player_index].station = {}		
		global.player[event.player_index].cur_priority = tonumber(string.match(element.name, "%d+"))		
		-- if global.priority[cur_priority].station then
			-- for i, stationX in ipairs(global.priority[cur_priority].station) do
				-- table.insert(station, stationX)
			-- end	
		-- end
		global.player[event.player_index].list = {}
		listidx = {}
		for _,stat in pairs(player.surface.find_entities_filtered{type="train-stop", name="subscriber-train-stop"}) do
			listidx[stat.backer_name] = stat.backer_name

			-- if curlist ~= station.backer_name then
				-- table.insert(list, {"",station.backer_name})
				-- curlist = station.backer_name
			-- end
		end
		for _,listidx in spairs(listidx, function(t,a,b) return t[b] > t[a] end) do
			table.insert(global.player[event.player_index].list,listidx)
		end
		-- for _, es in pairs(global.entitystation) do
			-- table.insert(list, {"",es.backer_name})
		-- end
		gui_open_station_frame(player, "edit")

	elseif string.find(element.name, "ps_remove")  then
		if (settings.startup["edit_admin"] and player.admin ) or
			(settings.startup["edit_admin"].value == false) then
			debugp(settings.startup["edit_admin"].value )
	--	if player.admin == true then
			global.player[event.player_index].cur_priority = tonumber(string.match(element.name, "%d+"))
			local id = global.priority[global.player[event.player_index].cur_priority].id
			local ok = true
			local station_frame = gui.station_frame
			if station_frame then
				player.print({"errors.del_station_frame"})
				ok = false
			end
			global.publishers = global.publishers or {}
			for i,publisher in pairs(global.publishers) do
				if publisher.priority.name == id.name then
					player.print({"errors.del_canc1"})
					ok = false
					break
				end
			end
			global.requests = global.requests or {}
			for i,request in pairs(global.requests) do
				if request.priority.name == id.name then
					player.print({"errors.del_canc2"})
					ok = false
					break
				end			
			end
			if ok == true then
				table.remove(global.priority, global.player[event.player_index].cur_priority)
				gui_open_pri_frame(player)		
			end
		else
			player.print({"errors.admin"})
		end
	
	elseif element.name == "tsm_update_station_button" then
		--debugp("edit")
		local value = {resource = global.player[event.player_index].resource, id = global.player[event.player_index].id, station = global.player[event.player_index].station}
		--debugp("current priority" .. cur_priority)
		global.priority[global.player[event.player_index].cur_priority].station = global.player[event.player_index].station
		--global.priority[cur_priority].station = table.deepcopy(station)
		--debugp("global priority " .. global.priority[cur_priority].name)
		--game.write_file("update_values",serpent.block(value),{comment=false})
		--game.write_file("globpri",serpent.block(global.priority),{comment=false})
		local id = global.player[event.player_index].id
		updaterequestedpublisher(global.priority[global.player[event.player_index].cur_priority].id.name)
		gui.station_frame.destroy()
		gui_open_pri_frame(player)
	--	game.write_file("globreqs",serpent.block(global.requests),{comment=false})
	elseif string.find(element.name, "pub_ping")  then
		local cur_pub = tonumber(string.match(element.name, "%d+"))	
		if global.publishers[cur_pub] then
			if global.publishers[cur_pub].entity.valid == true then
				local pub = global.publishers[cur_pub].entity
				map_ping(player,pub.position.x,pub.position.y,global.publishers[cur_pub].backer_name)
			else
				table.remove(global.requests, cur_pub)
			end
		end
	elseif string.find(element.name, "rq_ping")  then
		local cur_rq = tonumber(string.match(element.name, "%d+"))	
		if global.requests[cur_rq] then
			if global.requests[cur_rq].entity.valid == true then
				local rq = global.requests[cur_rq].entity
				map_ping(player,rq.position.x,rq.position.y,global.requests[cur_rq].backer_name)
			else
				table.remove(global.requests, cur_rq)
			end
		end		
	end		
end


local function isPS(entity)
	if (entity.name == "train-subscriber" or 
	    entity.name == "train-publisher" or 
		entity.name == "train-counter" or
		entity.name == "subscriber-train-stop" or
		entity.name == "publisher-train-stop") then
		return true
	end
	return false
end

local function push_sub_index(station, train)
	global.sub_index = global.sub_index or {}
	global.subscriptions = global.subscriptions or {}
--	if not check_req(station.backer_name, train) then
		-- indexed version
		global.subscriptions[train.id] = station.backer_name
		-- table.insert(global.subscriptions, {backer_name = station.backer_name, station = station, train = train})
		if global.sub_index[station.backer_name] == nil then
			global.sub_index[station.backer_name] = train.id		
		end
--	end	
end

local function pop_sub_index(backer_name, train_id)
	global.sub_index = global.sub_index or {}
	global.subscriptions = global.subscriptions or {}	
	-- indexed version
	if global.subscriptions[train_id] then
		global.subscriptions[train_id] = nil
	end
	
	for i,subs in pairs(global.subscriptions) do
		--debugp(i .. " " .. subs)
		-- if (sub.backer_name == backer_name and sub.train.id == train.id) then
			-- table.remove(global.subscriptions,i)
		-- end
		if (subs == backer_name and i ~= train_id) then
			global.sub_index[backer_name] = i
			return i
		end
	end
	--debugp{"deleting index entry"}
	global.sub_index[backer_name] = nil
	return nil
end


script.on_event(defines.events.on_built_entity, function(event)
	if isPS(event.created_entity) then
		-- debugp("PS entity")
		addPSToTable(event.created_entity, event.player_index)
	end

	if event.created_entity.name == "train-counter" then
		event.created_entity.operable = false
	end
	-- debugp(event.created_entity.name)
end)


script.on_event(defines.events.on_robot_built_entity, function(event)
	if isPS(event.created_entity) then
		addPSToTable(event.created_entity, 0, event.robot)
	end
	
	if event.created_entity.name == "train-counter" then
		event.created_entity.operable = false
	end
end)

local function on_preplayer_mined_item(event)
	if isPS(event.entity) then
		removePSFromTable(event.entity)
	end
end



script.on_event(defines.events.on_robot_pre_mined, function(event)
	if isPS(event.entity) then
		removePSFromTable(event.entity)
	end
end)

script.on_event(defines.events.on_entity_died, function(event)
	if isPS(event.entity) then
		removePSFromTable(event.entity)
	end
end)

script.on_event(defines.events.on_entity_renamed, function(event)
	-- train publishers and train counters cannot be renamed, so the only thing that can end up here is subscriber train stations
--	debugp("name change")
	if isPS(event.entity) then
		local backer_name = event.entity.backer_name
		local entity = event.entity
		if entity.name == "subscriber-train-stop" then
		--	debugp("rename from " .. event.old_name .. " to "  .. event.entity.backer_name)

			local train = nil
			local trains = entity.get_train_stop_trains()
		--game.write_file("trains",serpent.block(trains),{comment=false})
			if #trains > 0 then
				if trains[1].station then
					if trains[1].station.backer_name == backer_name then
						if global.subscriptions[trains[1].id] then
							pop_sub_index(event.old_name, trains[1].id)
							push_sub_index(entity, trains[1])
						end
					end
				end
			else
				-- if more than one subscriber of the same name then get_train_stop_trains will not find anything
				-- so check in global.subscriptions
				local pos = entity.position
				local entities = entity.surface.find_entities_filtered{area = {{pos.x-2, pos.y-2}, {pos.x+2, pos.y+2}},type = "locomotive"}
				local entity_names = {}
				for _,xentity in pairs(entities) do
					table.insert(entity_names,xentity.name)
					pop_sub_index(event.old_name, xentity.train.id)
					push_sub_index(entity, xentity.train)					
				end
			--	game.write_file("entities_found",serpent.block(entity_names),{comment=false})
			end
		end
		
		if entity.name == "publisher-train-stop" then
		-- Check counter entities
		--	debugp("publisher stop")
			local pos = entity.position
		--	debugp(pos.x .. "X," .. pos.y .. "Y")
			global.counters = global.counters or {}
			for _,counter in ipairs(entity.surface.find_entities_filtered{area = {{pos.x-2, pos.y-2}, {pos.x+2, pos.y+2}},name = "train-counter"}) do
				for i,cter in pairs(global.counters) do
					if cter.entity == counter then
					--	cter.backer_name = backer_name
						global.counters[i].backer_name = backer_name
						break
					end
				end
			end			

			-- for i,counter in pairs(global.counters) do
				-- if counter.backer_name == event.old_name then
					-- counter.backer_name = event.entity.backer_name
					-- break
				-- end
			-- end
		-- Check for publisher
			global.publishers = global.publishers or {}
			for _,publisher in ipairs(entity.surface.find_entities_filtered{area = {{pos.x-3, pos.y-3}, {pos.x+3, pos.y+3}},name = "train-publisher"}) do
			--	debugp("found pub")
				for i, pub in pairs(global.publishers) do
					if pub.entity.position.x == publisher.position.x and 
						pub.entity.position.y == publisher.position.y then					 
					--	pub.backer_name = backer_name
						global.publishers[i].backer_name = backer_name
						break
					end
				end
			end
			-- only change name of request linked station if no requester train stop has this name anymore
			if #entity.surface.get_train_stops({name=backer_name}) == 0 then		
				-- Check for open request
				global.requests = global.requests or {}
				for i, request in pairs(global.requests) do
					if request.backer_name == event.old_name then
							request.backer_name = backer_name
						break
					end
				end
			end		
		end
	end
	
end)

script.on_event(defines.events.on_player_rotated_entity, function(event)
-- can't actually rotate a placed station
	if event.entity.name == "publisher-train-stop" then
--[[ 		local surface = event.entity.surface
		--debugp("orientation = " .. event.entity.orientation)
		for i, counter in pairs(event.entity.surface.find_entities_filtered{area={{x=event.entity.position.x - 1,y=event.entity.position.y - 1},{x=event.entity.position.x + 1,y=event.entity.position.y + 1}},type="train-counter"}) do
			for i, counter in pairs(global.counters	) do
				if event.entity == counter.entity then
					table.remove(global.counters,i)
					event.entity.destroy()
					break
				end
			end
		end
		local new_entity = surface.create_entity{name="train-counter", position={event.entity.position.x + 1, event.entity.position.y}, force = event.entity.force }
		addPSToTable(new_entity, event.player_index) ]]
	end
end)

script.on_event(defines.events.on_runtime_mod_setting_changed, function(event)
	--debugp(event.setting)
	local player = game.players[event.player_index]
	if event.setting == "ps-tooltip" then
		local button_flow = mod_gui.get_button_flow(player)
		local button = button_flow.tm_sprite_button
		if button then
			button.destroy()
			get_sprite_button(player)
		end
		local gui = mod_gui.get_frame_flow(player)
		local frame = gui.tm_button_frame
		if frame then
			frame.destroy()
			frame = gui.add{
				type = "frame",
				name = "tm_button_frame",
				direction = "horizontal",
				style = mod_gui.frame_style
				}		
			gui_open_frame(player)
		end
	end
	if event.setting == "turbo_ups" then
		script.on_nth_tick(nil)	
		nth_tick()
	end
end)

local function check_fuel(locs)
	for _,loc in pairs(locs) do
		if lowFuel(loc) then
			return true
		end
	end
	return false
end

local function addFuelStop(train,numLocs)
	local schedule = train.schedule or {}
	if not train.schedule then
		schedule.records = {}
	end
	local fs = settings.startup['fuelstop_name'].value
	if schedule.records ~= nil then
		for _,record in pairs(schedule.records) do
			if record.station ~= nil then
		--	if string.find(record.station, "FuelStop")  then return end
				if string.find(record.station, fs, 1, true)  then return end
			end
		end
	end
--	local station_name = "FuelStop" .. numLocs
	local station_name = fs .. numLocs
	local record = {station = station_name, wait_conditions = {}}
	record.wait_conditions[#record.wait_conditions+1] = {type = "inactivity", compare_type = "and", ticks = 120 }
	-- local current = schedule.current or 0
	schedule.records[#schedule.records+1] = record

	train.schedule = schedule

	--global.removeFuelStop[train.id] = station_name
end

local function removeFuelStop(train)
	local schedule = train.schedule
	local fs = settings.startup['fuelstop_name'].value
	for i,record in pairs(schedule.records) do
	--	if string.find(record.station, "FuelStop")  then
		if record.station ~= nil then
			if string.find(record.station, fs, 1, true)  then

				table.remove(schedule.records,i)
				if i > #schedule.records then
					schedule.current = 1
				else
					schedule.current = i
				end	

				break
			end
		end
	end
	train.schedule = schedule
end

local function on_train_changed_state(event)
	if event.old_state == defines.train_state.arrive_station or 
		event.old_state == defines.train_state.manual_control then
		local train = event.train
		local station = train.station
		if station then
		if station.name == "subscriber-train-stop" then
			-- Either meet outstanding requirement
			checkreq = false
			check_req(station.backer_name, train)						
			-- if not check_req(station.backer_name, train) then
			if not checkreq then
				-- Is this a new index item, or index already exists? - push handles both true and false
				push_sub_index(station, train)
			end
		end
		local fs = settings.startup['fuelstop_name'].value
		--if string.find(station.backer_name , "FuelStop") then
		if string.find(station.backer_name , fs, 1, true) then
			Check_train_config(train, station)
		end
		
		
		-- low fuel check
		if train.manual_mode then return end
		
		if settings.global['min-fuel-amount'].value == 0 then return end
		local locs = train.locomotives
		if check_fuel(locs.front_movers) == true then
			addFuelStop(train, #locs.front_movers)		
		elseif check_fuel(locs.back_movers) then
			addFuelStop(train, #locs.back_movers)
		end	

		
	end
	
	elseif event.old_state == defines.train_state.wait_station then
		--debugp("Leaving wait station")
		local train = event.train
		global.subscriptions = global.subscriptions or {}
		if global.subscriptions == {} then return end
		local station = global.subscriptions[train.id]
		--debugp(station)

		if station ~= nil then
			--debugp("trying to pop data")
			pop_sub_index(station, train.id)
		end
		
		if train.schedule then
		local last = train.schedule.current
		if last == 1 then
			last = #train.schedule.records
		else
			last = last - 1
		end
		--debugp("test refuel remove" .. last)
		local fs = settings.startup["fuelstop_name"].value
	--	game.write_file("fs",serpent.block(fs),{comment=false})
	--	if string.find(train.schedule.records[last].station, "FuelStop")  then
		if train.schedule.records[last] ~= nil then
		if train.schedule.records[last].station ~= nil then
		if string.find(train.schedule.records[last].station, fs, 1, true) then
		--	debugp("Found")
			local schedule = {}
			schedule.records = train.schedule.records
			table.remove(schedule.records,last)
			schedule.current = last
			if last > #schedule.records then schedule.current = 1 end
			train.manual_mode = true
			train.schedule = schedule
			train.manual_mode = false
			clear_train_config()
		end
		end
		end
		end
	end
end

function gui_open(player, controller)

-- debugp("in gui open")
-- debugp(controller.name .. "in gui_open")
	local status,err = pcall(function()	
	if controller.name == "train-publisher" then
		local gui = mod_gui.get_frame_flow(player)
		-- in case gui element left open after destroy
		local status,err = pcall(function()
		local frame = gui.train_publisher
		frame.destroy()
		end)
				
		local frame = gui.add({ type = "frame", name = "train_publisher", direction = "vertical"})
		frame.caption = {"train-controller.train-publisher"}
		frame.add({ type = "label", name = "label", caption = {"train-controller.train-publisher-target"} })
		for i,publisher in pairs(global.publishers) do
			if publisher.entity == controller then
				if publisher.priority.name then
					global.cur_publisher = global.cur_publisher or {}
					global.cur_publisher[player.index] = i
					frame.add{type = "choose-elem-button", name = "Schema", elem_type = "signal", signal = {type = publisher.priority.type, name = publisher.priority.name}}
					for i,priority in pairs(global.priority) do
						if publisher.priority.name == priority.id.name then
							if frame.StationList then
								frame.StationList.destroy()
							end
							frame.add{type = "label", name = "StationList", caption = stationlist(priority)}
							-- process priority
							local proc_priority = "1"
							if publisher.proc_priority then	
								proc_priority = publisher.proc_priority
							end
							local proc_table = frame.add{type = "table", name = "proc_table",column_count = 2, style = "PubSub_table_style"}
							local proclab = proc_table.add{type = "label", name = "proclab", caption = {"train-controller.process-priority"}}
							local process = proc_table.add{type = "textfield", name = "process_priority", text = proc_priority}
							process.style.maximal_width = 40
							return
						end
						if frame.StationList then
							frame.StationList.destroy()
						end
						frame.add{type = "label", name = "StationList", caption = {"train-controller.not-defined"}}
					end
					-- process priority
					local proc_priority = "1"
					if publisher.proc_priority then	
						proc_priority = publisher.proc_priority
					end
					local proc_table = frame.add{type = "table", name = "proc_table",column_count = 2, style = "PubSub_table_style"}
					local proclab = proc_table.add{type = "label", name = "proclab", caption = {"train-controller.process-priority"}}
					local process = proc_table.add{type = "textfield", name = "process_priority", text = proc_priority}
					process.style.maximal_width = 40
					return
				end
				break
			end
		end
		frame.add{type = "choose-elem-button", name = "Schema", elem_type = "signal"}
	end
	end)
	if not status then
		for _,players in pairs(game.players) do
		players.print(err)
		end
	end	
end

function gui_close(player, controller)
	local status,err = pcall(function()		
	if controller.name == "train-publisher" then
		local gui = mod_gui.get_frame_flow(player)
		local frame = gui.train_publisher
		
		frame.destroy()
		if global.cur_publisher then
			if global.cur_publisher[player.index] then
				global.cur_publisher[player.index] = nil
			end
		end
	end
	end)
end

function upd_counters()
	if global.pending_req then
		pending_req()
	end
	if global.counters then
		--game.write_file("pobsub_counters",serpent.block(global.counters))
		for i, counter in pairs(global.counters) do
			--debugp("counter " .. counter.backer_name)
			if counter.station.valid == true then 
				updateCounters(counter, 2)
			else
				global.counters[i] = nil
			end
		end
	end
end

function upd_publishers()
	local tick = game.tick
	if global.publishers then
		for x, publisher in pairs(global.publishers) do
			if publisher.entity.valid == true then
				publisher.tick = publisher.tick or 0
				if publisher.tick < tick then
			--	debugp("Updating pub " .. publisher.backer_name)
					updatePublishers(publisher, x)
				end
			else 
				table.remove(global.publishers,x)
			end
		end
	end
end	

function pub_open()
	local status,err = pcall(function()
		global.controllerOpened = global.controllerOpened or {}
		for _, player in pairs(game.connected_players) do
			if player.opened ~= nil then
				if player.opened.name == "train-publisher" then
					if global.controllerOpened[player.name] == nil then
						gui_open(player, player.opened)
						global.controllerOpened[player.name] = player.opened
					end
				end
			end
			if player.opened == nil then 
				local object = global.controllerOpened[player.name]
				global.controllerOpened[player.name] = nil
				if not (object == nil ) then
					gui_close(player, object)
				end				
			end				
		end
	end)
end	

function nth_tick()
	if settings.global['turbo_ups'].value == false then
		script.on_nth_tick(57, upd_counters )
		script.on_nth_tick(37, upd_publishers )
		script.on_nth_tick(7, pub_open )
	else
		script.on_nth_tick(307, upd_counters )
		script.on_nth_tick(71, upd_publishers )
		script.on_nth_tick(11, pub_open )
	end
end

function addPSToTable(entity, player_index, robot)
	if entity.name == "subscriber-train-stop" then
	-- Check for subscriber-train-stop, and if train at station
		-- There should be three tables of subscriber train station info at the moment
			-- A complete list of all subscriber train stations - this can be replaced with player.surface.find_entities_filtered, currently global.entitystation
			-- A list of all subscriber stations with train, currently global.subscriptions
			-- A unique index to the subscriber stations with trains currently global.sub_index
		-- is there a train there
		local trains = entity.get_train_stop_trains()
		local status,err = pcall(function()
		for i, stp_train in pairs(trains) do
			if stp_train.station ~= nil then
				if stp_train.station.backer_name == entity.backer_name then
				-- we have a yes condition, so at the very least this train should be in global.subscriptions, but first check if it is the index item
					if not(global.sub_index[entity.backer_name]) then
					-- push the data
						push_sub_index(entity, stp_train)
						return
					else
					-- insert into global.subscriptions	
						global.subscriptions[stp_train.id] = entity.backer_name
					-- table.insert(global.subscriptions,stp_train.id)
						return
					end
				end
			end
		end	
	end)
	if not status then
		for _, player in pairs(game.players) do
			player.print(err)
		end
		-- game.players[1].print(err)
	end		
	end
	if entity.name == "train-publisher" then
		global.publishers = global.publishers or {}
		local within2 = false
		
		for _,station in pairs(entity.surface.find_entities_filtered{area={{x=entity.position.x - 2,y=entity.position.y - 2},{x=entity.position.x + 2,y=entity.position.y + 2}},type="train-stop"}) do
			table.insert(global.publishers, {entity = entity, backer_name = station.backer_name, enabled = false, priority = {}, request = false})
			within2 = true
			-- debugp("Publisher found at" .. station.backer_name)
		end
		if within2 == false and player_index > 0 then
			game.players[player_index].print("Requester needs to be within 2 tiles of requester train station")
		end
	end
	if entity.name == "train-counter" then
		global.counters = global.counters or {}
		for _,station in pairs(entity.surface.find_entities_filtered{area={{x=entity.position.x - 2,y=entity.position.y - 2},{x=entity.position.x + 2,y=entity.position.y + 2}},type="train-stop"}) do
			table.insert(global.counters, {entity = entity, backer_name = station.backer_name, station = station})
		end	
		entity.operable = false
		entity.minable = false
		entity.destructible = false		
	end
	if entity.name == "publisher-train-stop" then
	--debugp("orientation = " .. entity.orientation)
		global.pubstops = global.pubstops or {}
		table.insert(global.pubstops, {entity = entity})
		-- check for train-publishers in range
		for _,publisher in pairs(entity.surface.find_entities_filtered{area={{x=entity.position.x - 2,y=entity.position.y - 2},{x=entity.position.x + 2,y=entity.position.y + 2}},name="train-publisher"}) do
			for i,pub in pairs(global.publishers) do
				if pub.entity == publisher then
					if pub.backer_name == nil then
						pub.backer_name = entity.backer_name
						pub.request = false
					end
				end
			end
		end
		-- add train counter
		local x = entity.position.x
		local y = entity.position.y
		if entity.orientation == 0.75 then x = x + 1 end
		if entity.orientation == 0.25 then 
			x = x - 2 
			y = y - 1
		end
		if entity.orientation == 0 then 
			y = y + 1 
			x = x - 1
		end
		if entity.orientation == 0.5 then y = y - 2 end
		if not(entity.surface.can_place_entity{name="train-counter", position={x,y}}) then
			--entity.surface.mine_tile(x,y)
		--	debugp("player index " .. player_index)
			local mov_entity = entity.surface.find_entities({{x,y},{x+1,y+1}})
			if player_index > 0 then
				game.players[player_index].mine_entity(mov_entity[1])
			else
				local destroyed = mov_entity[1].destroy()
				-- if robot.valid == true then
					-- robot.mine_entity(mov_entity[1])
				-- end
			end
		end
		local ghost = entity.surface.find_entities_filtered{position={x + 0.5, y + 0.5},name="entity-ghost",ghost_name="train-counter"}[1]
		if ghost then
			global.pending_req = global.pending_req or {}
			global.pending_req[#global.pending_req+1] = {x + 0.5, y + 0.5}
			--	debugp(gh.name .. gh.ghost_name .. gh.position.x .. gh.position.y)
			local new_entity = ghost.revive()[2]	

		else
			local new_entity = entity.surface.create_entity{name="train-counter", position={x , y}, force = entity.force, fast_replace = true }
			new_entity.operable = false
			new_entity.minable = false
			new_entity.destructible = false
			addPSToTable(new_entity,0)
		end

	end
end

function removePSFromTable(entity)
	--debugp("In remove")

	if entity.name == "subscriber-train-stop" then
		-- check if index entry, or if there is a train there
		global.sub_index = global.sub_index or {}
		if global.sub_index == {} then return end
		if global.sub_index[entity.backer_name] then
			pop_sub_index(entity.backer_name, global.sub_index[entity.backer_name] )
		else
			-- check if train there
			local trains = entity.get_train_stop_trains()
			global.subscriptions = global.subscriptions or {}
			for _, stp_train in pairs(trains) do		
				if stp_train.station then
					if stp_train.station.backer_name == entity.backer_name then	
					-- indexed remove
						if global.subscriptions[stp_train.id] then
							global.subscriptions[stp_train.id] = nil
							return
						end
				
					-- for j, sub in ipairs(global.subscriptions) do
						-- if (sub.backer_name == entity.backer_name and sub.train.id == stp_train.id) then
							-- table.remove(global.subscriptions,j)
							-- return
						-- end
					-- end
					end
				end				
			end
		end
	end
	if entity.name == "train-publisher" then	
		for i, pubs in pairs(global.publishers) do
			if pubs.entity == entity then
				table.remove(global.publishers, i)
				break
			end
		end	
		if global.requests then
			for i, reqs in pairs(global.requests) do
				if reqs.entity == entity then
					table.remove(global.requests, i)
					break
				end
			end	
		end
	end
	if entity.name == "train-counter" then
		if global.counters then
			for i, counter in pairs(global.counters) do
				if counter.entity == entity then
					table.remove(global.counters, i)
					break
				end
			end
		end
	end
	if entity.name == "publisher-train-stop" then
		--debugp("Removing publisher-train-stop  " .. entity.backer_name)
		if global.pubstops then
			for i, pubstop in pairs(global.pubstops) do
				if pubstop.entity == entity then
					table.remove(global.pubstops, i)
					-- break
				end
			end			
		end
		--debugp("attempt to find counter element X"  .. entity.position.x  ..  " Y "  ..  entity.position.y)
		for i, counter in pairs(entity.surface.find_entities_filtered{area={{x=entity.position.x - 2,y=entity.position.y - 2},{x=entity.position.x + 2,y=entity.position.y + 2}},name="train-counter"}) do
		--	debugp("Counter found on surface")
		--	for i, counter in pairs(global.counters) do
			--	debugp("counter found in global counters")
			--	if entity == counter.station then
				--	debugp("attempting removal")
					--table.remove(global.counters,i)
					counter.destroy()
					--global.counters[i] = nil
					break
				--end
		end
		--end
		-- Also need to disable publishers near the remove pub train stop
		-- Lets try by removing the link to the train-stop and removing any active requests
	--	debugp("Looking for publishers at x " .. entity.position.x .. " y " .. entity.position.y)
		local localpubs = entity.surface.find_entities_filtered{area={{x=entity.position.x - 2,y=entity.position.y - 2},{x=entity.position.x + 2,y=entity.position.y + 2}},name="train-publisher"}
	--	debugp(entity.backer_name)
		--for _, lpubs in pairs(localpubs) do
		global.publishers = global.publishers or {}
		--	for _, pubs in pairs(global.publishers) do
		for _, pubs in pairs(localpubs) do
			for i, publisher in pairs(global.publishers) do
				if pubs == publisher.entity then
					publisher.backer_name = nil
					publisher.request = false
					if global.requests then
						for i, reqs in pairs(global.requests) do
							if reqs.entity == pubs then
								table.remove(global.requests, i)
								break
							end
						end	
					end
				end
			end
		end
	end
end


function debugp(text)
	if global.db_on == true then
		for _, player in pairs(game.players) do
			player.print(text)
		end
	end
end

function check_req(backer_name, train)
	--debugp("checking request for backer " .. backer_name)
	global.requests = global.requests or {}
	if not global.requests then 
		checkreq = false
		return  
	end
	local reqpri = {}
	reqpri = find_best_match(backer_name, train)
	if reqpri ~= {} then
		if reqpri.request ~= nil then
			--game.write_file("reqpri",serpent.block(reqpri),{comment=false})
			build_schedule(train, reqpri.request.backer_name, reqpri.priority)						
			-- find publisher and set publisher.request to false
			for k, publisher in pairs(global.publishers) do
				if reqpri.request.entity == publisher.entity then
					publisher.request = false
					table.remove(global.requests, reqpri.i)
					break
				end
			end

			-- update train-counter
			for _,counter in pairs(global.counters) do
				if counter.backer_name == reqpri.request.backer_name then
					updateCounters(counter,2)
					break
				end
			end
				checkreq = true
			return
	
		else
			checkreq = false
			return
		end
	else
		checkreq = false
		return
	end

end

function check_train_in_Sub_station(station)
	local train = nil
	if global.sub_index == nil then return nil end
	if global.sub_index[ station ] then
		local status,err = pcall(function()
		train = global.trains[global.sub_index[ station ]]
		debugp(global.sub_index[ station ])
		if train == nil then return nil end			
		if train.station == nil then
			pop_sub_index(station,global.sub_index[ station ])
			return check_train_in_Sub_station(station)
		end			
		if train.station.backer_name == nil then
			pop_sub_index(station,global.sub_index[ station ])
			return check_train_in_Sub_station(station)
		end
	--	debugp(train.station.backer_name .." : " .. station )
		if train.station.backer_name == station then	
		--	debugp(train.id)
			train_t = train.id
			return train.id
		else
			pop_sub_index(station,global.sub_index[ station ])
			return check_train_in_Sub_station(station)
			-- debugp(train.id)
			-- return train
		end
		end)
		if not status then
			pop_sub_index(station,global.sub_index[ station ])
			return check_train_in_Sub_station(station)
		end	
	end
	return nil	
end

local function match_req(publisher, x)
	-- Look up subscriptions table vs priorities
	-- debugp("In matching")
	local retvalue = false
	local status,err = pcall(function()	
	if not global.subscriptions then return false end
	-- debugp("Subscriptions exist")
	for i,priority in pairs(global.priority) do
		if publisher.priority.name == priority.id.name then
			if publisher.backer_name == nil then return false end
			if not priority.station then return false end
		 --	debugp("Selected priority stations exist")
			for _, station in ipairs(priority.station) do
			-- 	 debugp(station[2])
			--	if global.sub_index[ station[2] ] then
				if station ~= "" then 
				-- check that sub_index is in station, else pop and try again
				--	local train = global.trains[global.sub_index[ station[2] ]]
				train_t = nil
				check_train_in_Sub_station(station[2]) 
				
				if train_t ~= nil then 
			--	debugp("returned " .. train_t)
				local train = global.trains[train_t ] 
			
				if train ~= {} then
						--local train = global.trains[global.sub_index[ station[2] ]]
						
						build_schedule(train, publisher.backer_name, priority)				
						
						pop_sub_index(station[2],global.sub_index[ station[2] ])
						-- table.remove(global.subscriptions, i)
						-- update train-counter
						if settings.global['auto_updor'].value == true then 
							auto_update()						
						end
						for _,counter in pairs(global.counters) do
							--debugp(counter.backer_name .. " : " .. publisher.backer_name)
							if counter.backer_name == publisher.backer_name then
							--	debugp(counter.backer_name .. " : " .. publisher.backer_name)
								updateCounters(counter, 1)
								retvalue = true
								matchreq = retvalue
								return 	
								-- break
							end
						end						
						retvalue = true		
						matchreq = retvalue
						return 						
					-- end
				end
				else
					--  debugp("UnMatched " .. station[2] .. " : no train" )
				end
				end
			end
			break
		end
	end
	retvalue = false
	matchreq = retvalue	
	return 
	end)
	if not status then
			for _,players in pairs(game.players) do
			players.print(err)
			end
	end		
end

function updaterequestedpublisher(name, x)
	-- local status,err = pcall(function()	
	--debugp("In update requested pubs")
	--global.publishers = global.publishers or {}
	if global.publishers then
	for i,publisher in pairs(global.publishers) do
	--	debugp("Pub " .. publisher.backer_name)
		if not(publisher.entity.get_or_create_control_behavior().disabled) then
		--	debugp("enabled")
			if publisher.request and publisher.priority.name == name then 
			--	debugp("Testing")
				matchreq = false
				match_req(publisher, x)
			--	debugp(matchreq)
				if matchreq == true then
				--	debugp("Removing")
					-- remove existing request
					for j,request in pairs(global.requests) do
						if request.entity == publisher.entity then
						--	debugp("Removing")
							table.remove(global.requests, j)
							publisher.request = false
							--global.requests[j] = nil
							break
						end
					end
				end
			end
		end
	end
	end
end

function updatePublishers(publisher, x)
 	--debugp("In updatePub" .. game.tick)
--	local status,err = pcall(function()	
	if publisher.entity.get_or_create_control_behavior().disabled then
		return
	end
	if publisher.request then 
	--	debugp("Existing request "  .. publisher.backer_name)
		return 
	end
--	if not publisher.enabled then
	--	debugp(publisher.priority.name)
		if not publisher.priority then return end
		if not publisher.priority.name then return end
	-- 	debugp("pub name is " .. publisher.priority.name)
		matchreq = false
		match_req(publisher, x)
	-- 	debugp(matchreq)
		if matchreq == false then
			-- append a requestor record
			global.requests = global.requests or {}
			if global.requests then
				publisher.request = true
				for i,req in pairs(global.requests) do
					if publisher.entity == req.entity then
						req = publisher
					--	debugp("updated requestor record " .. publisher.priority.name)
						return
					end
				end
				publisher.tick = game.tick
				table.insert(global.requests, publisher)
				if settings.global['auto_updor'].value == true then 
					auto_update()						
				end
			 --	debugp("Added requestor record " .. publisher.priority.name)				
			end
		else
			if settings.global['turbo_ups'].value == false then
				publisher.tick = game.tick + 58
			else
				publisher.tick = game.tick + 311
			end
		--	debugp(publisher.tick)
		end
		-- publisher.enabled = true
--	end
	-- end)
	-- if not status then
		-- for _, player in pairs(game.players) do
			-- player.print(err)
		-- end
		-- -- game.players[1].print(err)
	-- end
end

function updateCounters(counter, dbp)	
	local status,err = pcall(function()	
	if counter.entity.valid == true then
	local cb = counter.entity.get_or_create_control_behavior()
	local signal = cb.get_signal(1)


	if dbp == 1 then
		--	debugp("count :" .. signal.count)
		-- traincount = signal.count + 1	 -- force increment
	end
	-- else
		local localstop = counter.station
		local trains = localstop.get_train_stop_trains()
		local traincount = 0
		for _, train in pairs(trains) do
			if train.path_end_stop == localstop then
				traincount = traincount + 1
			elseif train.station == localstop then
				traincount = traincount + 1
			elseif train.state == defines.train_state.no_path and
				train.schedule.records[train.schedule.current].station == localstop.backer_name then
				traincount = traincount + 1
			end
		end
	-- end
	
	cb.set_signal(1, {	signal = {
									type = "virtual",
									name = "train-counter"
									},
						count = traincount}
				)

	end
	end)
	if not status then
			for _,players in pairs(game.players) do
			players.print(err)
			end
			return			
	end	
end

script.on_event(defines.events.on_train_created, function(event)
	global.trains = global.trains or {}
	global.subscriptions = global.subscriptions or {}
	--if not global.subscriptions then return end
	global.trains[event.train.id] = event.train
	if event.old_train_id_1 then
		global.trains[event.old_train_id_1] = nil
		--debugp(event.old_train_id_1)
		if global.subscriptions[event.old_train_id_1] then
			if global.sub_index[global.subscriptions[event.old_train_id_1]] then
				pop_sub_index(global.subscriptions[event.old_train_id_1],event.old_train_id_1)
			else
				global.subscriptions[event.old_train_id_1] = nil
			end
		end
	end
	if event.old_train_id_2 then
		global.trains[event.old_train_id_2] = nil
		if global.subscriptions[event.old_train_id_2] then
			if global.sub_index[global.subscriptions[event.old_train_id_2]] then
				pop_sub_index(global.subscriptions[event.old_train_id_2],event.old_train_id_2)
			else
				global.subscriptions[event.old_train_id_2] = nil
			end
		end
	end		
end)

function fix_requests()
	for i,request in pairs(global.requests) do
		global.requests[i] = nil
	end
	for _,publisher in pairs(global.publishers) do
	--	debugp(publisher.backer_name .. publisher.entity.position.x .. " : " .. publisher.entity.position.y)
		local pubstop = game.surfaces[1].find_entities_filtered{area={{x=publisher.entity.position.x - 2,y=publisher.entity.position.y - 2},{x=publisher.entity.position.x + 2,y=publisher.entity.position.y + 2}},name="publisher-train-stop"}	
			publisher.backer_name = pubstop[1].backer_name
			publisher.request = false
	end
	for _,counter in pairs(global.counters) do
		local pubstop = game.surfaces[1].find_entities_filtered{area={{x=counter.entity.position.x - 2,y=counter.entity.position.y - 2},{x=counter.entity.position.x + 2,y=counter.entity.position.y + 2}},name="publisher-train-stop"}	
		counter.backer_name = pubstop[1].backer_name
	end

end

function fix_ps_stations()
	local j = 1
	while j <= #global.priority do
		local i = 1
		local x = 0
		debugp(#global.priority[j].station .. " priorities")
		while i <= #global.priority[j].station do
			debugp(i .. " : " .. j)
			if #global.priority[j].station[i] == 1 then
				x = x + 1
				table.remove(global.priority[j].station, i)
				debugp("removed")
			else
				i = i + 1
				debugp("ok")
			end
		end
		j = j + 1
	end
	debugp(x)
	return x
end

script.on_configuration_changed(on_configuration_changed)
script.on_init(onLoad)
script.on_event(defines.events.on_pre_player_mined_item, on_preplayer_mined_item)
script.on_event(defines.events.on_train_changed_state, on_train_changed_state)
script.on_event(defines.events.on_player_created, on_player_created)
script.on_event(defines.events.on_player_joined_game, on_player_joined_game )
script.on_event(defines.events.on_gui_click, on_gui_click)
script.on_event(defines.events.on_gui_elem_changed, on_gui_elem_changed)
script.on_event(defines.events.on_gui_selection_state_changed, on_gui_selection_state_changed)
script.on_load(nth_tick)
script.on_event(defines.events.on_gui_checked_state_changed, on_gui_checked_state_changed)

commands.add_command("CreateIndex", {"createindex_help"}, function(event)
	global.sub_index = {}
	global.subscriptions = global.subscriptions or {}
	-- global.subscriptions now keyed by train
	for i,subs in pairs(global.subscriptions) do
		if global.sub_index[subs.backer_name] == nil then
--			global.sub_index[subs.backer_name] = subs.train.id
			global.sub_index[subs.backer_name] = i
		--	debugp(subs.backer_name .. " : " .. global.sub_index[subs.backer_name])
		end
	end
end)

commands.add_command("trainInfo", {"trainInfo_help"}, function(event)
	local trains = game.player.surface.get_trains()
	global.trains = {}
	for i,train in pairs(trains) do
	--	debugp(train.id)
		global.trains[train.id] = train
	end
end)

commands.add_command("debug_on", {"trainInfo_help"}, function(event)
	global.db_on = true
end)

commands.add_command("debug_off", {"trainInfo_help"}, function(event)
	global.db_on = false
end)

commands.add_command("Get_requests_file", {"get requests file help"}, function(event)
	game.write_file("requests_log",serpent.block(global.requests),{comment=false})
end)

commands.add_command("Get_sub_index", {"get sub index help"}, function(event)
	game.write_file("sub_index",serpent.block(global.sub_index),{comment=false})
end)

commands.add_command("Get_trains", {"get trains help"}, function(event)
	game.write_file("trains",serpent.block(global.trains),{comment=false})
end)

commands.add_command("Get_pslogs", {"get pslogs help"}, function(event)
	game.write_file("trainpubs",serpent.block(global.publishers),{comment=false})
	game.write_file("trainreqs",serpent.block(global.requests),{comment=false})
	game.write_file("trainpriorities",serpent.block(global.priority),{comment=false})
 	game.write_file("counters",serpent.block(global.counters),{comment=false})
	game.write_file("subscriptions",serpent.block(global.counters),{comment=false})
end)

commands.add_command("fix_requests", {"fix_requests_help"}, function(event)
	fix_requests()
end)

commands.add_command("rebuild_trains", {"rebuild_trains_help"}, function(event)
	local surface = nil
	global.trains = {}
	for _, surface in pairs(game.surfaces) do
		local trains = surface.get_trains()
		for i,train in pairs(trains) do
		 --	debugp(train.id)
			global.trains[train.id] = train
		end
	end
end)

commands.add_command("Get_pubstops", {"get pubstops help"}, function(event)
	game.write_file("pubstops",serpent.block(global.pubstops),{comment=false})
end)

commands.add_command("Validate_index", {"validate index help"}, function(event)
	local train = nil
	for i,sub_i in pairs(global.sub_index) do
		train = global.trains[global.sub_index[ i ]]
		if not(train) then
			pop_sub_index(i,global.sub_index[ i ])
		elseif not(train.valid) then
			pop_sub_index(i,global.sub_index[ i ])
		elseif not (train.station) then
			pop_sub_index(i,global.sub_index[ i ])
		end
	end	
end)

commands.add_command("fix_ps_stations", {"fix ps stations help"}, function(event)
	local x = 0
	x = fix_ps_stations()
	if x ~= nil then
		game.players[event.player_index].print(x .. " nil stations removed")
	else
		game.players[event.player_index].print("0 nil stations removed")
	end
end)

commands.add_command("fix_raw_wood", {"fix raw wood help"}, function(event)
	fix_raw_wood()
	game.players[event.player_index].print("raw-wood instances have been corrected to wood")
end)